---
title: DOM improvements in Firefox 3
slug: Mozilla/Firefox/Releases/3/DOM_improvements
tags:
  - DOM
  - Firefox 3
---
<div>{{FirefoxSidebar}}</div><p>{{ Fx_minversion_header(3) }}</p>

<p>Firefox 3 offers a number of improvements to the <a href="en/DOM">Document Object Model</a> (DOM), especially in regard to support for extensions to the DOM added by other browsers. This article provides a list of those improvements as well as links to more detailed documentation.</p>

<ul>
 <li>The Internet Explorer <code><a href="/en-US/docs/Web/API/Element/clientTop">clientTop</a></code> and <code><a href="/en-US/docs/Web/API/Element/clientLeft">clientLeft</a></code> DOM extensions are now supported.</li>
 <li>The <code><a href="/en-US/docs/Web/API/Window/fullScreen">window.fullScreen</a></code> property is now always accurate no matter where it is read, even in content. Previously it would return <code>false</code> inaccurately ({{ Bug(127013) }}).</li>
 <li>The <code><a href="en/DOM/element.getClientRects">getClientRects</a></code> and <code><a href="en/DOM/element.getBoundingClientRect">getBoundingClientRect</a></code> DOM extensions are now supported (see {{ Bug(174397) }}).</li>
 <li>The Internet Explorer <code><a href="en/DOM/document.elementFromPoint">elementFromPoint</a></code> DOM extension is now supported ({{ Bug(199692) }}).</li>
 <li>The Internet Explorer <code><a href="en/DOM/element.oncut">oncut</a></code>, <code><a href="en/DOM/element.oncopy">oncopy</a></code>, and <code><a href="en/DOM/element.onpaste">onpaste</a></code> DOM extensions are now supported ({{ Bug(280959) }}).</li>
 <li>Added privileged-code-only getters for <code>Node.nodePrincipal</code>, <code>Node.baseURIObject</code>, and <code><a href="en/DOM/document.documentURIObject">document.documentURIObject</a></code>. Chrome code must not touch (get or set) these properties on an unwrapped content object (e.g. on a <code>wrappedJSObject</code> of an <code><a href="en/XPCNativeWrapper">XPCNativeWrapper</a></code>), see {{ Bug(324464) }} for details.</li>
 <li>The Web Applications 1.0 (HTML5) <code><a href="en/DOM/document.getElementsByClassName">getElementsByClassName()</a></code> DOM method is now supported.</li>
 <li>The Web Applications 1.0 (HTML5) <code><a href="en/DOM/window.postMessage">window.postMessage</a></code> DOM method is now supported. This method allows a limited, opt-in form of client-side communication between windows not necessarily on the same domain.</li>
 <li>The <code>charCode</code> value of the <code>keypress</code> event is changed to an ASCII character if the accelerator key is pressed. Otherwise the <code>charCode</code> is the unmodified character (excepting <kbd>Shift</kbd> state). See <a href="en/Gecko_Keypress_Event">Gecko Keypress Event</a>.</li>
</ul>

<h3 id="See_also">See also</h3>

<ul>
 <li><a href="en/Firefox_3_for_developers">Firefox 3 for developers</a></li>
 <li><a href="en/CSS_improvements_in_Firefox_3">CSS improvements in Firefox 3</a></li>
 <li><a href="en/DOM">DOM</a></li>
</ul>
